/* libing - collection of usefull objects
(c) 2003 Alexey Voinov <voins@altlinux.org>
*/
#ifndef _CONFIG_BASE_H
#define _CONFIG_BASE_H

#include <iosfwd>
#include <string>
#include <map>

namespace Ing
{
class ConfigBase
{
	typedef std::map<std::string, std::string> item_list;
public:
	virtual ~ConfigBase(void)
	{}

	virtual void parse_stream(std::istream& is,
				  const std::string& filename) = 0;
	void parse_file(const std::string& filename);
	void parse_buffer(const char* data, size_t len);

	bool boolean(const std::string& name) const;
	std::string text(const std::string& name) const; //return copy of the value: we can change it
	void reset_option(const std::string& group, const std::string& name);

protected:
	virtual void begin_group(const std::string& group);
	virtual void end_group(const std::string& group);
	virtual void setup_option(const std::string& group,
				  const std::string& name,
				  const std::string& value,
				  const std::string& type);

private:
	item_list items;

	friend class ParserBase;
};
};

#endif // _CONFIG_BASE_H
