/* libing - collection of usefull objects
(c) 2002,2003
Stanislav Ievlev <inger@altlinux.org>
*/
#ifndef ING_FILESYSTEM_H
#define ING_FILESYSTEM_H

#include <fts.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>

#include <libing/ingerr.h>

namespace Ing
{

struct DirItem
{
	std::string	path; //root path to access it
	std::string	accesspath; //access path to access it
	const struct	stat *st; //stat structure
	long	depth; //directory depth
	int	fd; //opened file's descriptor
};

//walk throw all files in specified directory
class DirStream
{
public:
	explicit
	DirStream(const std::string& path);
	~DirStream();

	bool	get(DirItem& item);

	bool	fail() const { return __failed; } //return status of the stream
operator void* () const { return this->fail() ? 0 : const_cast<DirStream*>(this); }
	bool operator! () const { return fail(); };
private:
	bool __failed;   //stream status
	FTS *t; 	//FTS handle
	int	fd;	//opened file descriptor for the current element
	struct	stat *st; //stat structure of the current element
};

DirStream &operator>>(DirStream& __dir, DirItem& __item);
DirStream &operator>>(DirStream& __dir, std::string& __path);

};


#endif
