/* libing - collection of usefull objects
(c) 2003 Alexey Voinov <voins@altlinux.org>
*/
#ifndef _PARSER_BASE_H
#define _PARSER_BASE_H
#include <libing/config_base.h>

namespace Ing
{
class ParserBase
{
protected:
	ParserBase(ConfigBase& config, const std::string& group)
			: config_(config), group_(group)
	{}

	void begin_group(const std::string& group)
	{
		config_.begin_group(group);
	}

	void end_group(const std::string& group)
	{
		config_.end_group(group);
	}

	void setup_option(const std::string& group,
			  const std::string& name,
			  const std::string& value,
			  const std::string& type)
	{
		config_.setup_option(group, name, value, type);
	}

	ConfigBase& config_;
	const std::string group_;
};
};

#endif // _PARSER_BASE_H

