/* libing - collection of usefull objects
(c) 2002,2003
Stanislav Ievlev <inger@altlinux.org>
*/
#ifndef ING_PERLRE_H
#define ING_PERLRE_H

#include <pcre/pcre.h>
#include <string>

namespace Ing
{

class PerlRE
{
public:
	PerlRE(const std::string& str, int oveccount = 10);
	virtual ~PerlRE();
	bool match(const std::string& str);
	void walk(const std::string& str);
protected:
	virtual void found_at(int startoffset, int stopoffset);
private:
	pcre *re;
	int oveccount;
};

bool operator==(const std::string& __str, Ing::PerlRE& __exp);
bool operator==(Ing::PerlRE& __exp, const std::string& __str);
bool operator==(Ing::PerlRE& __exp, const char* __str);
bool operator==(const char* __str, Ing::PerlRE& __exp);

bool operator!=(const std::string& __str, Ing::PerlRE& __exp);
bool operator!=(Ing::PerlRE& __exp, const std::string& __str);
bool operator!=(Ing::PerlRE& __exp, const char* __str);
bool operator!=(const char* __str, Ing::PerlRE& __exp);

};



#endif
