/* libing - collection of usefull objects
(c) 2002,2003
Stanislav Ievlev <inger@altlinux.org>
*/

#ifndef ING_REGULAREXPR_H
#define ING_REGULAREXPR_H

#include <sys/types.h>
#include <regex.h>
#include <string>
#include <vector>

namespace Ing
{

//generic class to process strings with classic regular expressions (GlibC's regexp)
class RegularExpr
{
public:
	RegularExpr(const std::string& pattern, int count = 10, int format = 1);
	~RegularExpr();

	bool match(const std::string& line);
	int count() const ;
	std::string operator[](int i) const;
private:
	std::vector<std::string> fields;
	int matches;
	regex_t	re;
};

bool operator==(const std::string& __str, Ing::RegularExpr& __exp);
bool operator==(Ing::RegularExpr& __exp, const std::string& __str);
bool operator==(Ing::RegularExpr& __exp, const char* __str);
bool operator==(const char* __str, Ing::RegularExpr& __exp);

bool operator!=(const std::string& __str, Ing::RegularExpr& __exp);
bool operator!=(Ing::RegularExpr& __exp, const std::string& __str);
bool operator!=(Ing::RegularExpr& __exp, const char* __str);
bool operator!=(const char* __str, Ing::RegularExpr& __exp);

};


#endif
